/**
 * 地图
 */
class Map {

    map
    deviceLayer = L.layerGroup()

    options = {
        // L.latLng
        centerLatLng: undefined,

        // L.latLngBounds
        mapBounds: undefined
    }

    constructor(tileUrl, options) {

        Object.assign(this.options, options);

        let tileLayer = new L.TileLayer(tileUrl, {
            minZoom: 8,
            maxZoom: 18,
            coordType: 'gcj02'
        });

        this.map = new L.Map('map', {
            center: this.options.centerLatLng,
            zoom: 12,
            minZoom: 8,
            maxZoom: 18,
            maxBounds: this.options.mapBounds,
            layers: [tileLayer],
            attributionControl: false,
            doubleClickZoom: false,
            zoomControl: false
        });

        this.map.addLayer(this.deviceLayer); //设备图层

        L.control.scale().addTo(this.map); //比例尺

        //显示经纬度和地图层级
        let this_ = this;
        this.map.addEventListener("mousemove", function (e) {
            this_.showMousePosition(e);
            this_.showMapZoom();
        });
        this.map.addEventListener("zoomend", function (e) {
            this_.showMapZoom();
        });
    }

    showMousePosition(e) {
        if (!this.mousePositionDiv) {
            this.mousePositionDiv = $('#mouseposition');
        }
        this.mousePositionDiv.text(e.latlng.lng.toFixed(8) + ", " + e.latlng.lat.toFixed(8));
    }

    showMapZoom() {
        if (!this.mapZoomDiv) {
            this.mapZoomDiv = $('#mapzoom');
        }
        this.mapZoomDiv.text(this.map.getZoom().toString());
    }
}

export { Map }
